base-files, busybox: fix 22279, simplify code and get rid of awk
authorJo-Philipp Wich <jow@openwrt.org>
Sun, 18 Jul 2010 18:36:12 +0000 (18:36 +0000)
committerJo-Philipp Wich <jow@openwrt.org>
Sun, 18 Jul 2010 18:36:12 +0000 (18:36 +0000)
SVN-Revision: 22282

package/base-files/files/bin/login.sh
package/busybox/files/telnet

index 00f2f81ab421b13dd97ed19793c540ad7f5fd1d4..a64c84e1e2dc918086cbadad0b78366a29cd7f09 100755 (executable)
@@ -1,25 +1,16 @@
 #!/bin/sh
-# Copyright (C) 2006 OpenWrt.org
+# Copyright (C) 2006-2010 OpenWrt.org
 
-
-regpassresult="0"
-grep '^root:[^!]' /etc/passwd >&- 2>&-
-regpassresult="$?"
-shadowresult="0"
-if [ -e "/etc/shadow" ]; then
-       grep '^root:[^!]' /etc/shadow >&- 2>&-
-        shadowresult="$?"
-fi
-[ "$regpassresult" = "0" ] && [ "$shadowresult" = "0" ] && [ -z "$FAILSAFE" ] && {
-    echo "Login failed."
-    exit 0
-} || {
+if grep -qs '^root:[^!]' /etc/passwd /etc/shadow && [ -z "$FAILSAFE" ]; then
+       echo "Login failed."
+       exit 0
+else
 cat << EOF
  === IMPORTANT ============================
   Use 'passwd' to set your login password
   this will disable telnet and enable SSH
  ------------------------------------------
 EOF
-}
+fi
 
 exec /bin/ash --login
index 2fbbb23575f58364e06e95d25bd9495f49d80f77..b8823379b9a8e1c61546090c7527447fe9aa5275 100755 (executable)
@@ -1,17 +1,24 @@
 #!/bin/sh /etc/rc.common
-# Copyright (C) 2006 OpenWrt.org
+# Copyright (C) 2006-2010 OpenWrt.org
 START=50
 
+has_root_pwd() {
+       local pwd=$([ -f "$1" ] && cat "$1")
+             pwd="${pwd#*root:}"
+             pwd="${pwd%%:*}"
+
+       test -n "${pwd#!}"
+}
+
 start() {
-       if      [ \! -f /etc/passwd ] || \
-               ( awk -F: '/^root:/ && ($2 != "") && ($2 !~ /\!/) {exit 1}' /etc/passwd 2>/dev/null && \
-               awk -F: '/^root:/ && ($2 != "") && ($2 !~ /\!/) {exit 1}' /etc/shadow 2>/dev/null ) || \
-               ( [ \! -x /usr/sbin/dropbear ] && [ \! -x /usr/sbin/sshd ] )
-       then \
+       if ( ! has_root_pwd /etc/passwd && ! has_root_pwd /etc/shadow ) || \
+          ( [ ! -x /usr/sbin/dropbear ] && [ ! -x /usr/sbin/sshd ] );
+       then
                telnetd -l /bin/login.sh
        fi
 }
 
 stop() {
-       killall telnetd
+       killall telnetd 2>/dev/null
 }
+